<script>
  import { scaleLinear, scaleBand } from "d3-scale";
  import { axisBottom, axisLeft } from "d3-axis";
  import { select } from "d3-selection";

  // Dimensions
  const width = 600;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 30, left: 60 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Array
  const data = [
    { service: "Netflix", viewers: 2.9 },
    { service: "Amazon Prime Video", viewers: 1.3 },
    { service: "Disney+", viewers: 2.1 },
    { service: "Hulu", viewers: 0.9 },
    { service: "Apple TV", viewers: 1.1 },
    { service: "Rakuten", viewers: 0.4 }
  ];
  const services = [];
  data.forEach((box) => {
    services.push(box.service);
  });

  const scaleY = scaleLinear([0, 3], [0, innerHeight]);
  const scaleYAxis = scaleLinear([0, 3], [innerHeight, 0])
  const scaleX = scaleBand().domain(services)
    .range([0, innerWidth])
    .padding(0.1)
 

  const yAxis = axisLeft().scale(scaleYAxis);
  let g;
  $: select(g).call(yAxis);

  const xAxis = axisBottom().scale(scaleX);
  let x;
  $: select(x).call(xAxis);

</script>

<!-- setting a viewBox and max-width allows the SVG to shrink but not grow! -->
<svg viewbox="0 0 {width} {height}" style="max-width: {width}px">
  <g transform={`translate(${margin.left},${margin.top})`}>
  {#each data as box}
  <rect
    x={scaleX(box.service)}
    y={innerHeight - scaleY(box.viewers)}
    height={scaleY(box.viewers)}
    width={scaleX.bandwidth()}
    style="opacity:0.3"
  />
{/each}
<g bind:this={g} />
<g bind:this={x} transform="translate(0, {height - 40})" />


  </g>
  <text transform="translate(15, {innerHeight / 2 + 40}), rotate(-90)"
    >Viewers
  </text>

</svg>
